您的位置:首页 > 其它

POJ - 3126----Prime Path

2017-01-30 22:07 288 查看
The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.

— It is a matter of security to change such things every now and then, to keep the enemy in the dark.

— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!

— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.

— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!

— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.

— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.

— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.

— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?

— In fact, I do. You see, there is this programming contest going on… Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.

1033

1733

3733

3739

3779

8779

8179

The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input
3
1033 8179
1373 8017
1033 1033
Sample Output
6
7
0


题目大意:

输入:给两个4位的素数,

操作:每次只能改变一位数字,且每次改变完后得到的数还是素数

输出:将前一个素数转化为后一个素数需要的步数。

思路:先将四位数的素数找出来存下,然后就简单的BFS即可

#include<iostream>
#include<cstring>
#include<queue>
#include<cstdio>
#include<cmath>
using namespace std;

const int MAX = 10000;

struct vary{
int step;//记录步数
bool visit;//素数的访问标记
};

int prime[MAX];
vary A[MAX];

//素数制表
void isprime(void){
int i,j;
for(i=1000 ; i<=MAX ; i++){
for(j=2 ; j<i ; j++){
if(i%j == 0){
break;
}
}
if(j==i){
prime[i] = i;
}
}
}

int BFS(int start,int end){
queue<int> Q;
memset(A,0,sizeof(A));

A[start].visit = true;//起始a已访问
Q.push(start);

while(!Q.empty()){
int tem = Q.front();
int t[4];//分离数字
Q.pop();

//找到
if(tem == end){
cout<<A[tem].step<<endl;
return 1;
}

t[0]=tem/1000;
t[1]=tem%1000/100;
t[2]=tem%100/10;
t[3]=tem%10;
//改变素数的一位数字入队
for(int i=0 ; i<4 ; i++){//要改的位
int k = t[i];
for(int j=0 ; j<10 ; j++){//要改的数
t[i] = j;
int temp=t[0]*1000+t[1]*100+t[2]*10+t[3];

//与原数不同       未访问过          为素数
if(temp!=tem && !A[temp].visit && prime[temp]!=0){
A[temp].step = A[tem].step+1;
A[temp].visit = true;
Q.push(temp);
}
}
t[i] = k;//还原该位;
}
}
return 0;
}
int main(void){
int a,b,n;
isprime();//预处理

cin>>n;
for(int i=0 ; i<n ; i++){
cin>>a>>b;
if(BFS(a,b) == 0){
cout<<"Impossible"<<endl;
}
}

return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签:  path poj BFS